searchNodes=[{"ref":"Phoenix.PubSub.html","title":"Phoenix.PubSub","type":"module","doc":"Realtime Publisher/Subscriber service. Getting started You start Phoenix.PubSub directly in your supervision tree: {Phoenix.PubSub, name: :my_pubsub} You can now use the functions in this module to subscribe and broadcast messages: iex&gt; alias Phoenix.PubSub iex&gt; PubSub.subscribe :my_pubsub, &quot;user:123&quot; :ok iex&gt; Process.info(self(), :messages) {:messages, []} iex&gt; PubSub.broadcast :my_pubsub, &quot;user:123&quot;, {:user_update, %{id: 123, name: &quot;Shane&quot;}} :ok iex&gt; Process.info(self(), :messages) {:messages, [{:user_update, %{id: 123, name: &quot;Shane&quot;}}]} Adapters Phoenix PubSub was designed to be flexible and support multiple backends. There are two officially supported backends: Phoenix.PubSub.PG2 - the default adapter that ships as part of Phoenix.PubSub. It uses Distributed Elixir, directly exchanging notifications between servers Phoenix.PubSub.Redis - uses Redis to exchange data between servers. It requires the :phoenix_pubsub_redis dependency See Phoenix.PubSub.Adapter to implement a custom adapter. Custom dispatching Phoenix.PubSub allows developers to perform custom dispatching by passing a dispatcher module which is responsible for local message deliveries. The dispatcher must be available on all nodes running the PubSub system. The dispatch/3 function of the given module will be invoked with the subscriptions entries, the broadcaster identifier (either a pid or :none), and the message to broadcast. You may want to use the dispatcher to perform special delivery for certain subscriptions. This can be done by passing the :metadata option during subscriptions. For instance, Phoenix Channels use a custom value to provide &quot;fastlaning&quot;, allowing messages broadcast to thousands or even millions of users to be encoded once and written directly to sockets instead of being encoded per channel."},{"ref":"Phoenix.PubSub.html#broadcast/4","title":"Phoenix.PubSub.broadcast/4","type":"function","doc":"Broadcasts message on given topic across the whole cluster. pubsub - The name of the pubsub system topic - The topic to broadcast to, ie: &quot;users:123&quot; message - The payload of the broadcast A custom dispatcher may also be given as a fourth, optional argument. See the &quot;Custom dispatching&quot; section in the module documentation."},{"ref":"Phoenix.PubSub.html#broadcast!/4","title":"Phoenix.PubSub.broadcast!/4","type":"function","doc":"Raising version of broadcast!/4."},{"ref":"Phoenix.PubSub.html#broadcast_from/5","title":"Phoenix.PubSub.broadcast_from/5","type":"function","doc":"Broadcasts message on given topic from the given process across the whole cluster. pubsub - The name of the pubsub system topic - The topic to broadcast to, ie: &quot;users:123&quot; message - The payload of the broadcast A custom dispatcher may also be given as a fourth, optional argument. See the &quot;Custom dispatching&quot; section in the module documentation."},{"ref":"Phoenix.PubSub.html#broadcast_from!/5","title":"Phoenix.PubSub.broadcast_from!/5","type":"function","doc":"Raising version of broadcast_from!/5."},{"ref":"Phoenix.PubSub.html#child_spec/1","title":"Phoenix.PubSub.child_spec/1","type":"function","doc":"Returns a child specification for pubsub with the given options. The :name is required as part of options. The remaining options are described below. Options :name - the name of the pubsub to be started :adapter - the adapter to use (defauls to Phoenix.PubSub.PG2) :pool_size - number of pubsub partitions to launch (defaults to one partition for every 4 cores)"},{"ref":"Phoenix.PubSub.html#direct_broadcast/5","title":"Phoenix.PubSub.direct_broadcast/5","type":"function","doc":"Broadcasts message on given topic to a given node. node_name - The target node name pubsub - The name of the pubsub system topic - The topic to broadcast to, ie: &quot;users:123&quot; message - The payload of the broadcast DO NOT use this function if you wish to broadcast to the current node, as it is always serialized, use local_broadcast/4 instead. A custom dispatcher may also be given as a fifth, optional argument. See the &quot;Custom dispatching&quot; section in the module documentation."},{"ref":"Phoenix.PubSub.html#direct_broadcast!/5","title":"Phoenix.PubSub.direct_broadcast!/5","type":"function","doc":"Raising version of direct_broadcast!/5."},{"ref":"Phoenix.PubSub.html#local_broadcast/4","title":"Phoenix.PubSub.local_broadcast/4","type":"function","doc":"Broadcasts message on given topic only for the current node. pubsub - The name of the pubsub system topic - The topic to broadcast to, ie: &quot;users:123&quot; message - The payload of the broadcast A custom dispatcher may also be given as a fourth, optional argument. See the &quot;Custom dispatching&quot; section in the module documentation."},{"ref":"Phoenix.PubSub.html#local_broadcast_from/5","title":"Phoenix.PubSub.local_broadcast_from/5","type":"function","doc":"Broadcasts message on given topic from a given process only for the current node. pubsub - The name of the pubsub system topic - The topic to broadcast to, ie: &quot;users:123&quot; message - The payload of the broadcast A custom dispatcher may also be given as a fifth, optional argument. See the &quot;Custom dispatching&quot; section in the module documentation."},{"ref":"Phoenix.PubSub.html#node_name/1","title":"Phoenix.PubSub.node_name/1","type":"function","doc":"Returns the node name of the PubSub server."},{"ref":"Phoenix.PubSub.html#subscribe/3","title":"Phoenix.PubSub.subscribe/3","type":"function","doc":"Subscribes the caller to the PubSub adapter&#39;s topic. server - The Pid registered name of the server topic - The topic to subscribe to, for example: &quot;users:123&quot; opts - The optional list of options. See below. Duplicate Subscriptions Callers should only subscribe to a given topic a single time. Duplicate subscriptions for a Pid/topic pair are allowed and will cause duplicate events to be sent; however, when using Phoenix.PubSub.unsubscribe/2, all duplicate subscriptions will be dropped. Options :metadata - provides metadata to be attached to this subscription. The metadata can be used by custom dispatching mechanisms. See the &quot;Custom dispatching&quot; section in the module documentation"},{"ref":"Phoenix.PubSub.html#unsubscribe/2","title":"Phoenix.PubSub.unsubscribe/2","type":"function","doc":"Unsubscribes the caller from the PubSub adapter&#39;s topic."},{"ref":"Phoenix.PubSub.html#t:dispatcher/0","title":"Phoenix.PubSub.dispatcher/0","type":"type","doc":""},{"ref":"Phoenix.PubSub.html#t:message/0","title":"Phoenix.PubSub.message/0","type":"type","doc":""},{"ref":"Phoenix.PubSub.html#t:node_name/0","title":"Phoenix.PubSub.node_name/0","type":"type","doc":""},{"ref":"Phoenix.PubSub.html#t:t/0","title":"Phoenix.PubSub.t/0","type":"type","doc":""},{"ref":"Phoenix.PubSub.html#t:topic/0","title":"Phoenix.PubSub.topic/0","type":"type","doc":""},{"ref":"Phoenix.PubSub.Adapter.html","title":"Phoenix.PubSub.Adapter","type":"behaviour","doc":"Specification to implement a custom PubSub adapter."},{"ref":"Phoenix.PubSub.Adapter.html#c:broadcast/4","title":"Phoenix.PubSub.Adapter.broadcast/4","type":"callback","doc":"Broadcasts the given topic, message, and dispatcher to all nodes in the cluster (except the current node itself)."},{"ref":"Phoenix.PubSub.Adapter.html#c:child_spec/1","title":"Phoenix.PubSub.Adapter.child_spec/1","type":"callback","doc":"Returns a child specification that mounts the processes required for the adapter. child_spec will receive all options given Phoenix.PubSub. Note, however, that the :name under options is the name of the complete PubSub system. The name of the process to be used by adapter is under the :adapter_name key."},{"ref":"Phoenix.PubSub.Adapter.html#c:direct_broadcast/5","title":"Phoenix.PubSub.Adapter.direct_broadcast/5","type":"callback","doc":"Broadcasts the given topic, message, and dispatcher to given node in the cluster (it may point to itself)."},{"ref":"Phoenix.PubSub.Adapter.html#c:node_name/1","title":"Phoenix.PubSub.Adapter.node_name/1","type":"callback","doc":"Returns the node name as an atom or a binary."},{"ref":"Phoenix.PubSub.Adapter.html#t:adapter_name/0","title":"Phoenix.PubSub.Adapter.adapter_name/0","type":"type","doc":""},{"ref":"Phoenix.PubSub.Application.html","title":"Phoenix.PubSub.Application","type":"module","doc":""},{"ref":"Phoenix.PubSub.Application.html#start/2","title":"Phoenix.PubSub.Application.start/2","type":"function","doc":"Called when an application is started. This function is called when an application is started using Application.start/2 (and functions on top of that, such as Application.ensure_started/2). This function should start the top-level process of the application (which should be the top supervisor of the application&#39;s supervision tree if the application follows the OTP design principles around supervision). start_type defines how the application is started: :normal - used if the startup is a normal startup or if the application is distributed and is started on the current node because of a failover from another node and the application specification key :start_phases is :undefined. {:takeover, node} - used if the application is distributed and is started on the current node because of a failover on the node node. {:failover, node} - used if the application is distributed and is started on the current node because of a failover on node node, and the application specification key :start_phases is not :undefined. start_args are the arguments passed to the application in the :mod specification key (for example, mod: {MyApp, [:my_args]}). This function should either return {:ok, pid} or {:ok, pid, state} if startup is successful. pid should be the PID of the top supervisor. state can be an arbitrary term, and if omitted will default to []; if the application is later stopped, state is passed to the stop/1 callback (see the documentation for the c:stop/1 callback for more information). use Application provides no default implementation for the start/2 callback. Callback implementation for Application.start/2."},{"ref":"Phoenix.PubSub.BroadcastError.html","title":"Phoenix.PubSub.BroadcastError","type":"exception","doc":""},{"ref":"Phoenix.PubSub.PG2.html","title":"Phoenix.PubSub.PG2","type":"module","doc":"Phoenix PubSub adapter based on :pg/:pg2. It runs on Distributed Erlang and is the default adapter."},{"ref":"Phoenix.PubSub.PG2.html#child_spec/1","title":"Phoenix.PubSub.PG2.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Phoenix.PubSub.Supervisor.html","title":"Phoenix.PubSub.Supervisor","type":"module","doc":""},{"ref":"Phoenix.PubSub.Supervisor.html#child_spec/1","title":"Phoenix.PubSub.Supervisor.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Phoenix.PubSub.Supervisor.html#init/1","title":"Phoenix.PubSub.Supervisor.init/1","type":"function","doc":"Callback invoked to start the supervisor and during hot code upgrades. Developers typically invoke Supervisor.init/2 at the end of their init callback to return the proper supervision flags. Callback implementation for Supervisor.init/1."},{"ref":"Phoenix.PubSub.Supervisor.html#start_link/1","title":"Phoenix.PubSub.Supervisor.start_link/1","type":"function","doc":""},{"ref":"Phoenix.Tracker.html","title":"Phoenix.Tracker","type":"behaviour","doc":"Provides distributed Presence tracking to processes. The Tracker API is used as a facade for a pool of Phoenix.Tracker.Shards. The responsibility of which calls go to which Shard is determined based on the topic, on which a given function is called. Tracker shards use a heartbeat protocol and CRDT to replicate presence information across a cluster in an eventually consistent, conflict-free manner. Under this design, there is no single source of truth or global process. Each node runs a pool of Phoenix.Tracker.Shards and node-local changes are replicated across the cluster and handled locally as a diff of changes. tracker - The name of the tracker handler module implementing the Phoenix.Tracker behaviour tracker_opts - The list of options to pass to the tracker handler pool_opts - The list of options used to construct the shard pool Required pool_opts: :name - The name of the server, such as: MyApp.Tracker This will also form the common prefix for all shard names :pubsub_server - The name of the PubSub server, such as: MyApp.PubSub Optional pool_opts: :broadcast_period - The interval in milliseconds to send delta broadcasts across the cluster. Default 1500 :max_silent_periods - The max integer of broadcast periods for which no delta broadcasts have been sent. Default 10 (15s heartbeat) :down_period - The interval in milliseconds to flag a replica as temporarily down. Default broadcast_period * max_silent_periods * 2 (30s down detection). Note: This must be at least 2x the broadcast_period. :permdown_period - The interval in milliseconds to flag a replica as permanently down, and discard its state. Note: This must be at least greater than the down_period. Default 1_200_000 (20 minutes) :clock_sample_periods - The numbers of heartbeat windows to sample remote clocks before collapsing and requesting transfer. Default 2 :max_delta_sizes - The list of delta generation sizes to keep before falling back to sending entire state. Defaults [100, 1000, 10_000]. :log_level - The log level to log events, defaults :debug and can be disabled with false :pool_size - The number of tracker shards to launch. Default 1 Implementing a Tracker To start a tracker, first add the tracker to your supervision tree: children = [ # ... {MyTracker, [name: MyTracker, pubsub_server: MyApp.PubSub]} ] Next, implement MyTracker with support for the Phoenix.Tracker behaviour callbacks. An example of a minimal tracker could include: defmodule MyTracker do use Phoenix.Tracker def start_link(opts) do opts = Keyword.merge([name: __MODULE__], opts) Phoenix.Tracker.start_link(__MODULE__, opts, opts) end def init(opts) do server = Keyword.fetch!(opts, :pubsub_server) {:ok, %{pubsub_server: server, node_name: Phoenix.PubSub.node_name(server)}} end def handle_diff(diff, state) do for {topic, {joins, leaves}} &lt;- diff do for {key, meta} &lt;- joins do IO.puts &quot;presence join: key \\&quot;\#{key}\\&quot; with meta \#{inspect meta}&quot; msg = {:join, key, meta} Phoenix.PubSub.direct_broadcast!(state.node_name, state.pubsub_server, topic, msg) end for {key, meta} &lt;- leaves do IO.puts &quot;presence leave: key \\&quot;\#{key}\\&quot; with meta \#{inspect meta}&quot; msg = {:leave, key, meta} Phoenix.PubSub.direct_broadcast!(state.node_name, state.pubsub_server, topic, msg) end end {:ok, state} end end Trackers must implement start_link/1, init/1, and handle_diff/2. The init/1 callback allows the tracker to manage its own state when running within the Phoenix.Tracker server. The handle_diff callback is invoked with a diff of presence join and leave events, grouped by topic. As replicas heartbeat and replicate data, the local tracker state is merged with the remote data, and the diff is sent to the callback. The handler can use this information to notify subscribers of events, as done above. Special Considerations Operations within handle_diff/2 happen in the tracker server&#39;s context. Therefore, blocking operations should be avoided when possible, and offloaded to a supervised task when required. Also, a crash in the handle_diff/2 will crash the tracker server, so operations that may crash the server should be offloaded with a Task.Supervisor spawned process."},{"ref":"Phoenix.Tracker.html#get_by_key/3","title":"Phoenix.Tracker.get_by_key/3","type":"function","doc":"Gets presences tracked under a given topic and key pair. server_name - The registered name of the tracker server topic - The Phoenix.PubSub topic key - The key of the presence Returns a lists of presence metadata. Examples iex&gt; Phoenix.Tracker.get_by_key(MyTracker, &quot;lobby&quot;, &quot;user1&quot;) [{#PID&lt;0.88.0&gt;, %{name: &quot;User 1&quot;}, {#PID&lt;0.89.0&gt;, %{name: &quot;User 1&quot;}]"},{"ref":"Phoenix.Tracker.html#graceful_permdown/1","title":"Phoenix.Tracker.graceful_permdown/1","type":"function","doc":"Gracefully shuts down by broadcasting permdown to all replicas. Examples iex&gt; Phoenix.Tracker.graceful_permdown(MyTracker) :ok"},{"ref":"Phoenix.Tracker.html#c:handle_diff/2","title":"Phoenix.Tracker.handle_diff/2","type":"callback","doc":""},{"ref":"Phoenix.Tracker.html#init/1","title":"Phoenix.Tracker.init/1","type":"function","doc":""},{"ref":"Phoenix.Tracker.html#c:init/1","title":"Phoenix.Tracker.init/1","type":"callback","doc":""},{"ref":"Phoenix.Tracker.html#list/2","title":"Phoenix.Tracker.list/2","type":"function","doc":"Lists all presences tracked under a given topic. server_name - The registered name of the tracker server topic - The Phoenix.PubSub topic Returns a lists of presences in key/metadata tuple pairs. Examples iex&gt; Phoenix.Tracker.list(MyTracker, &quot;lobby&quot;) [{123, %{name: &quot;user 123&quot;}}, {456, %{name: &quot;user 456&quot;}}]"},{"ref":"Phoenix.Tracker.html#start_link/3","title":"Phoenix.Tracker.start_link/3","type":"function","doc":""},{"ref":"Phoenix.Tracker.html#track/5","title":"Phoenix.Tracker.track/5","type":"function","doc":"Tracks a presence. server_name - The registered name of the tracker server pid - The Pid to track topic - The Phoenix.PubSub topic for this presence key - The key identifying this presence meta - The map of metadata to attach to this presence A process may be tracked multiple times, provided the topic and key pair are unique for any prior calls for the given process. Examples iex&gt; Phoenix.Tracker.track(MyTracker, self(), &quot;lobby&quot;, u.id, %{stat: &quot;away&quot;}) {:ok, &quot;1WpAofWYIAA=&quot;} iex&gt; Phoenix.Tracker.track(MyTracker, self(), &quot;lobby&quot;, u.id, %{stat: &quot;away&quot;}) {:error, {:already_tracked, #PID&lt;0.56.0&gt;, &quot;lobby&quot;, &quot;123&quot;}}"},{"ref":"Phoenix.Tracker.html#untrack/2","title":"Phoenix.Tracker.untrack/2","type":"function","doc":""},{"ref":"Phoenix.Tracker.html#untrack/4","title":"Phoenix.Tracker.untrack/4","type":"function","doc":"Untracks a presence. server_name - The registered name of the tracker server pid - The Pid to untrack topic - The Phoenix.PubSub topic to untrack for this presence key - The key identifying this presence All presences for a given Pid can be untracked by calling the Phoenix.Tracker.untrack/2 signature of this function. Examples iex&gt; Phoenix.Tracker.untrack(MyTracker, self(), &quot;lobby&quot;, u.id) :ok iex&gt; Phoenix.Tracker.untrack(MyTracker, self()) :ok"},{"ref":"Phoenix.Tracker.html#update/5","title":"Phoenix.Tracker.update/5","type":"function","doc":"Updates a presence&#39;s metadata. server_name - The registered name of the tracker server pid - The Pid being tracked topic - The Phoenix.PubSub topic to update for this presence key - The key identifying this presence meta - Either a new map of metadata to attach to this presence, or a function. The function will receive the current metadata as input and the return value will be used as the new metadata Examples iex&gt; Phoenix.Tracker.update(MyTracker, self(), &quot;lobby&quot;, u.id, %{stat: &quot;zzz&quot;}) {:ok, &quot;1WpAofWYIAA=&quot;} iex&gt; Phoenix.Tracker.update(MyTracker, self(), &quot;lobby&quot;, u.id, fn meta -&gt; Map.put(meta, :away, true) end) {:ok, &quot;1WpAofWYIAA=&quot;}"},{"ref":"Phoenix.Tracker.html#t:presence/0","title":"Phoenix.Tracker.presence/0","type":"type","doc":""},{"ref":"Phoenix.Tracker.html#t:topic/0","title":"Phoenix.Tracker.topic/0","type":"type","doc":""},{"ref":"Phoenix.Tracker.Shard.html","title":"Phoenix.Tracker.Shard","type":"behaviour","doc":"Keeps track of presences in a single shard"},{"ref":"Phoenix.Tracker.Shard.html#child_spec/1","title":"Phoenix.Tracker.Shard.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Phoenix.Tracker.Shard.html#get_by_key/3","title":"Phoenix.Tracker.Shard.get_by_key/3","type":"function","doc":""},{"ref":"Phoenix.Tracker.Shard.html#graceful_permdown/1","title":"Phoenix.Tracker.Shard.graceful_permdown/1","type":"function","doc":""},{"ref":"Phoenix.Tracker.Shard.html#c:handle_diff/2","title":"Phoenix.Tracker.Shard.handle_diff/2","type":"callback","doc":""},{"ref":"Phoenix.Tracker.Shard.html#init/1","title":"Phoenix.Tracker.Shard.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state}, except that it also sets a timeout. See the &quot;Timeouts&quot; section in the module documentation for more information. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"Phoenix.Tracker.Shard.html#c:init/1","title":"Phoenix.Tracker.Shard.init/1","type":"callback","doc":""},{"ref":"Phoenix.Tracker.Shard.html#list/2","title":"Phoenix.Tracker.Shard.list/2","type":"function","doc":""},{"ref":"Phoenix.Tracker.Shard.html#name_for_number/2","title":"Phoenix.Tracker.Shard.name_for_number/2","type":"function","doc":""},{"ref":"Phoenix.Tracker.Shard.html#name_for_topic/3","title":"Phoenix.Tracker.Shard.name_for_topic/3","type":"function","doc":""},{"ref":"Phoenix.Tracker.Shard.html#start_link/3","title":"Phoenix.Tracker.Shard.start_link/3","type":"function","doc":""},{"ref":"Phoenix.Tracker.Shard.html#track/5","title":"Phoenix.Tracker.Shard.track/5","type":"function","doc":""},{"ref":"Phoenix.Tracker.Shard.html#untrack/2","title":"Phoenix.Tracker.Shard.untrack/2","type":"function","doc":""},{"ref":"Phoenix.Tracker.Shard.html#untrack/4","title":"Phoenix.Tracker.Shard.untrack/4","type":"function","doc":""},{"ref":"Phoenix.Tracker.Shard.html#update/5","title":"Phoenix.Tracker.Shard.update/5","type":"function","doc":""},{"ref":"Phoenix.Tracker.Shard.html#validate_down_period/2","title":"Phoenix.Tracker.Shard.validate_down_period/2","type":"function","doc":""},{"ref":"Phoenix.Tracker.Shard.html#validate_permdown_period/2","title":"Phoenix.Tracker.Shard.validate_permdown_period/2","type":"function","doc":""},{"ref":"Phoenix.Tracker.Shard.html#t:presence/0","title":"Phoenix.Tracker.Shard.presence/0","type":"type","doc":""},{"ref":"Phoenix.Tracker.Shard.html#t:t/0","title":"Phoenix.Tracker.Shard.t/0","type":"type","doc":""},{"ref":"Phoenix.Tracker.Shard.html#t:topic/0","title":"Phoenix.Tracker.Shard.topic/0","type":"type","doc":""},{"ref":"Phoenix.Tracker.State.html","title":"Phoenix.Tracker.State","type":"module","doc":"Provides an ORSWOT CRDT."},{"ref":"Phoenix.Tracker.State.html#clocks/1","title":"Phoenix.Tracker.State.clocks/1","type":"function","doc":"Returns the causal context for the set."},{"ref":"Phoenix.Tracker.State.html#compact/1","title":"Phoenix.Tracker.State.compact/1","type":"function","doc":"Compacts a sets causal history. Called as needed and after merges."},{"ref":"Phoenix.Tracker.State.html#delta_size/1","title":"Phoenix.Tracker.State.delta_size/1","type":"function","doc":"Returns the dize of the delta."},{"ref":"Phoenix.Tracker.State.html#extract/3","title":"Phoenix.Tracker.State.extract/3","type":"function","doc":"Extracts the set&#39;s elements from ets into a mergeable list. Used when merging two sets."},{"ref":"Phoenix.Tracker.State.html#get_by_key/3","title":"Phoenix.Tracker.State.get_by_key/3","type":"function","doc":"Returns a list of elements for the topic who belong to an online replica."},{"ref":"Phoenix.Tracker.State.html#get_by_pid/2","title":"Phoenix.Tracker.State.get_by_pid/2","type":"function","doc":"Returns all elements for the pid."},{"ref":"Phoenix.Tracker.State.html#get_by_pid/4","title":"Phoenix.Tracker.State.get_by_pid/4","type":"function","doc":"Returns the element matching the pid, topic, and key."},{"ref":"Phoenix.Tracker.State.html#get_by_topic/2","title":"Phoenix.Tracker.State.get_by_topic/2","type":"function","doc":"Returns a list of elements for the topic who belong to an online replica."},{"ref":"Phoenix.Tracker.State.html#has_delta?/1","title":"Phoenix.Tracker.State.has_delta?/1","type":"function","doc":"Checks if set has a non-empty delta."},{"ref":"Phoenix.Tracker.State.html#join/5","title":"Phoenix.Tracker.State.join/5","type":"function","doc":"Adds a new element to the set."},{"ref":"Phoenix.Tracker.State.html#leave/2","title":"Phoenix.Tracker.State.leave/2","type":"function","doc":"Removes all elements from the set for the given pid."},{"ref":"Phoenix.Tracker.State.html#leave/4","title":"Phoenix.Tracker.State.leave/4","type":"function","doc":"Removes an element from the set."},{"ref":"Phoenix.Tracker.State.html#merge/2","title":"Phoenix.Tracker.State.merge/2","type":"function","doc":"Merges two sets, or a delta into a set. Returns a 3-tuple of the updated set, and the joined and left elements. Examples iex&gt; {s1, joined, left} = Phoenix.Tracker.State.merge(s1, Phoenix.Tracker.State.extract(s2)) {%Phoenix.Tracker.State{}, [...], [...]}"},{"ref":"Phoenix.Tracker.State.html#merge_deltas/2","title":"Phoenix.Tracker.State.merge_deltas/2","type":"function","doc":""},{"ref":"Phoenix.Tracker.State.html#new/2","title":"Phoenix.Tracker.State.new/2","type":"function","doc":"Creates a new set for the replica. Examples iex&gt; Phoenix.Tracker.State.new(:replica1) %Phoenix.Tracker.State{...}"},{"ref":"Phoenix.Tracker.State.html#online_list/1","title":"Phoenix.Tracker.State.online_list/1","type":"function","doc":"Returns a list of elements in the set belonging to an online replica."},{"ref":"Phoenix.Tracker.State.html#remove_down_replicas/2","title":"Phoenix.Tracker.State.remove_down_replicas/2","type":"function","doc":"Removes all elements for replicas that are permanently gone."},{"ref":"Phoenix.Tracker.State.html#replica_down/2","title":"Phoenix.Tracker.State.replica_down/2","type":"function","doc":"Marks a replica as down in the set and returns left users."},{"ref":"Phoenix.Tracker.State.html#replica_up/2","title":"Phoenix.Tracker.State.replica_up/2","type":"function","doc":"Marks a replica as up in the set and returns rejoined users."},{"ref":"Phoenix.Tracker.State.html#reset_delta/1","title":"Phoenix.Tracker.State.reset_delta/1","type":"function","doc":"Resets the set&#39;s delta."},{"ref":"Phoenix.Tracker.State.html#tracked_key/4","title":"Phoenix.Tracker.State.tracked_key/4","type":"function","doc":"Performs table lookup for tracked key in the topic. Filters out those present on downed replicas."},{"ref":"Phoenix.Tracker.State.html#tracked_values/3","title":"Phoenix.Tracker.State.tracked_values/3","type":"function","doc":"Performs table lookup for tracked elements in the topic. Filters out those present on downed replicas."},{"ref":"Phoenix.Tracker.State.html#t:clock/0","title":"Phoenix.Tracker.State.clock/0","type":"type","doc":""},{"ref":"Phoenix.Tracker.State.html#t:cloud/0","title":"Phoenix.Tracker.State.cloud/0","type":"type","doc":""},{"ref":"Phoenix.Tracker.State.html#t:clouds/0","title":"Phoenix.Tracker.State.clouds/0","type":"type","doc":""},{"ref":"Phoenix.Tracker.State.html#t:context/0","title":"Phoenix.Tracker.State.context/0","type":"type","doc":""},{"ref":"Phoenix.Tracker.State.html#t:delta/0","title":"Phoenix.Tracker.State.delta/0","type":"type","doc":""},{"ref":"Phoenix.Tracker.State.html#t:ets_id/0","title":"Phoenix.Tracker.State.ets_id/0","type":"type","doc":""},{"ref":"Phoenix.Tracker.State.html#t:key/0","title":"Phoenix.Tracker.State.key/0","type":"type","doc":""},{"ref":"Phoenix.Tracker.State.html#t:key_meta/0","title":"Phoenix.Tracker.State.key_meta/0","type":"type","doc":""},{"ref":"Phoenix.Tracker.State.html#t:meta/0","title":"Phoenix.Tracker.State.meta/0","type":"type","doc":""},{"ref":"Phoenix.Tracker.State.html#t:name/0","title":"Phoenix.Tracker.State.name/0","type":"type","doc":""},{"ref":"Phoenix.Tracker.State.html#t:pid_lookup/0","title":"Phoenix.Tracker.State.pid_lookup/0","type":"type","doc":""},{"ref":"Phoenix.Tracker.State.html#t:t/0","title":"Phoenix.Tracker.State.t/0","type":"type","doc":""},{"ref":"Phoenix.Tracker.State.html#t:tag/0","title":"Phoenix.Tracker.State.tag/0","type":"type","doc":""},{"ref":"Phoenix.Tracker.State.html#t:topic/0","title":"Phoenix.Tracker.State.topic/0","type":"type","doc":""},{"ref":"Phoenix.Tracker.State.html#t:value/0","title":"Phoenix.Tracker.State.value/0","type":"type","doc":""},{"ref":"Phoenix.Tracker.State.html#t:values/0","title":"Phoenix.Tracker.State.values/0","type":"type","doc":""}]